#!/usr/bin/env python3

import argparse # argparse.ArgumentParser()
import os.path # os.path.isfile()

SEPARATOR=";"

def unpack(line, separator, limit = 20):
    retarr = line.strip().split(separator)
    for x in range(len(retarr), limit):
        retarr.append("")
    return retarr

if __name__ == '__main__':
    # parse the command line arguments
    parser = argparse.ArgumentParser(description="generate the lpdamin commands")
    parser.add_argument("file", help="the path to the csv-file containing all the printers.")
    args = parser.parse_args()

file = open(args.file, 'r') 

count, nprinters = 0, 0
for line in file:

    # for the list 2020_01_20_Schulen_Inventar_Printer.csv
    #hostname, serial, ip, contact, telefon, email, schulhaus, strasse, plz, stock, bem, profile, model, *rest = unpack(line, SEPARATOR)

    # for the list 2020_10_20_Schulen_Inventar_Printer.csv
    ip, hostname, contact, location, profile, serial, model, *rest = unpack(line, SEPARATOR)
    
    model = model.replace(" ", "")

    # for the list 2020_01_20_Schulen_Inventar_Printer.csv
    #schulhaus = schulhaus.replace(" ", "-")
    #schulhaus = schulhaus.replace("/", "")
    #stock = stock.replace(" ", "-")
    #stock = stock.replace("/", "-")
    #bem = bem.replace(" ", "-")
    #bem = bem.replace("/", "-")
    #location = "{0}, {1}, {2}, {3}, {4}".format(schulhaus, strasse, plz, stock, bem)

    try:
        ppd, _ = model.split("/")
    except ValueError as e:
        ppd = model

    ppdfile = "develop-{0}.ppd".format(ppd.lower());

    # for the list 2020_01_20_Schulen_Inventar_Printer.csv
    #name = "{0}-{1}-{2}-Develop-{3}-{4}".format(schulhaus, stock, bem, ppd, hostname)

    # for the list 2020_10_20_Schulen_Inventar_Printer.csv
    name = "{0}-Develop-{1}-{2}".format(location, ppd, hostname)
    name = name.replace(",", "-")
    name = name.replace(" ", "-")
    name = name.replace("/", "-")
    name = name.replace("--", "-")

    if count == 0:
        print("# INFO: This is the first line")
        print("# ERROR: NOMODEL/NOIP: ", line.strip())

    if model == "" or ip == "":
        print("# ERROR: NOMODEL/NOIP: ", line.strip())

    if count != 0 and ip != "" and model != "":

        if not os.path.isfile("ppds/" + ppdfile):
            print("# ERROR: ppd file does not exist: {0}".format("ppds/" + ppdfile))

        if ppd == "ineo+458":
            options = "-o Model=C458 -o Finisher=FS533 -o KOPunch=PK519-4"
        else:
            options = ""

        # TODO adjust the 181!!
        print(("echo \"# Adding printer {hostname} ({i}/181)\"\n"
            + "echo \"scale=0; 100*{i}/181\" | bc\n"
            + "lpadmin -v ipp://{ip} -L \"{location}\" -D \"Develop {model}\" -p \"{name}\" -m \"{ppdfile}\" -E {options}").format(
            i = count,
            hostname = hostname,
            ip = ip,
            location = location,
            model = model,
            name = name,
            ppdfile = ppdfile,
            options = options,
            ))
        nprinters += 1
    count += 1
  
# Closing files 
file.close()

print("# INFO: total entries: {0}, import: {1}, errors: {2}".format(count, nprinters, count - nprinters))